diff --git a/core/src/aos_system.c b/core/src/aos_system.c
index c9b3072..97270e6 100644
--- a/core/src/aos_system.c
+++ b/core/src/aos_system.c
@@ -1139,23 +1156,26 @@ void aosSysShutdownFinal(aos_shutdown_t shutdown)
         break;
     }
   } else {
-    // fallback if bootloader was found to be invalid
-    aosprintf("Bootloader incompatible or not available!\n");
+    // fallback if AMiRo-BLT was found to be invalid
+    aosprintf("ERROR: AMiRo-BLT incompatible or not available!\n");
     aosThdMSleep(10);
     chSysDisable();
   }
+#endif /* (AMIROOS_CFG_BOOTLOADER == AOS_BOOTLOADER_AMiRoBLT) */
 
   return;
 }
 
+#endif /* ((AMIROOS_CFG_SSSP_ENABLE == true) && (AMIROOS_CFG_SSSP_SHUTDOWN != true)) || ((AMIROOS_CFG_SSSP_ENABLE != true) && (AMIROOS_CFG_BOOTLOADER == AOS_BOOTLOADER_AMiRoBLT)) */
+
 /**
  * @brief   Generic callback function for GPIO interrupts.
  *
  * @return  Pointer to the callback function.
  */
-palcallback_t aosSysGetStdExtiCallback(void)
+palcallback_t aosSysGetStdGpioCallback(void)
 {
-  return _extiCallback;
+  return _gpioCallback;
 }
 
 /** @} */
diff --git a/kernel/ChibiOS b/kernel/ChibiOS
index 065a318..a9ba0b8 160000
--- a/kernel/ChibiOS
+++ b/kernel/ChibiOS
@@ -1 +1 @@
-Subproject commit 065a3182147545188d83a71c0881e2d7bac58de2
+Subproject commit a9ba0b88416cff96c60c59f1d8bf8469fd328ef2
diff --git a/modules/DiWheelDrive_1-1/aosconf.h b/modules/DiWheelDrive_1-1/aosconf.h
index e45bcbd..0f93be9 100644
--- a/modules/DiWheelDrive_1-1/aosconf.h
+++ b/modules/DiWheelDrive_1-1/aosconf.h
@@ -33,7 +33,7 @@ along with this program.  If not, see <http://www.gnu.org/licenses/>.
  */
 #define _AMIRO_OS_CFG_
 #define AMIRO_OS_CFG_VERSION_MAJOR              2
-#define AMIRO_OS_CFG_VERSION_MINOR              0
+#define AMIRO_OS_CFG_VERSION_MINOR              1
 
 #include <stdbool.h>
 
@@ -80,14 +80,14 @@ along with this program.  If not, see <http://www.gnu.org/licenses/>.
 #endif /* !defined(OS_CFG_PROFILE) */
 
 /**
- * @brief   Mask for the control thread to listen to certain IO events.
+ * @brief   Mask for the control thread to listen to certain GPIO events.
  * @note    Any mandatory events (e.g. for SSSP) are enabled implicitely despite this configuration.
  */
-#if !defined(OS_CFG_MAIN_LOOP_IOEVENT_MASK)
-  #define AMIROOS_CFG_MAIN_LOOP_IOEVENT_MASK    0
-#else /* !defined(OS_CFG_MAIN_LOOP_IOEVENT_MASK) */
-  #define AMIROOS_CFG_MAIN_LOOP_IOEVENT_MASK    OS_CFG_MAIN_LOOP_IOEVENT_MASK
-#endif /* !defined(OS_CFG_MAIN_LOOP_IOEVENT_MASK) */
+#if !defined(OS_CFG_MAIN_LOOP_GPIOEVENT_FLAGSMASK)
+  #define AMIROOS_CFG_MAIN_LOOP_GPIOEVENT_FLAGSMASK 0
+#else /* !defined(OS_CFG_MAIN_LOOP_GPIOEVENT_FLAGSMASK) */
+  #define AMIROOS_CFG_MAIN_LOOP_GPIOEVENT_FLAGSMASK OS_CFG_MAIN_LOOP_GPIOEVENT_FLAGSMASK
+#endif /* !defined(OS_CFG_MAIN_LOOP_GPIOEVENT_FLAGSMASK) */
 
 /**
  * @brief   Timeout value when waiting for events in the main loop in microseconds.
@@ -103,6 +103,21 @@ along with this program.  If not, see <http://www.gnu.org/licenses/>.
 
 /*===========================================================================*/
 /**
+ * @name Bootloader configuration
+ * @{
+ */
+/*===========================================================================*/
+
+/**
+ * @brief   Identifier of the instaled bootloader (if any).
+ * @note    See aos_bootloader.h file for a list of available settings.
+ */
+#define AMIROOS_CFG_BOOTLOADER                  AOS_BOOTLOADER_AMiRoBLT
+
+/** @} */
+
+/*===========================================================================*/
+/**
  * @name SSSP (Startup Shutdown Synchronization Protocol) configuration.
  * @{
  */
@@ -118,6 +133,46 @@ along with this program.  If not, see <http://www.gnu.org/licenses/>.
 #endif /* !defined(OS_CFG_SSSP_ENABLE) */
 
 /**
+ * @brief   Flag to indicate, whether the SSSP startup sequence shall be executed by AMiRo-OS.
+ * @details This setting must be false in case another software (e.g. a bootloader) handles the initial stages of the SSSP startup phase.
+ */
+#if !defined(OS_CFG_SSSP_STARTUP)
+  #define AMIROOS_CFG_SSSP_STARTUP              false
+#else
+  #define AMIROOS_CFG_SSSP_STARTUP              OS_CFG_SSSP_STARTUP
+#endif
+
+/**
+ * @brief   Flag to indicate, whether the SSSP shutdown sequence shall be executed by AMiRo-OS.
+ * @details This setting should be false in case another software (e.g. a bootloader) handles the final stages of the SSSP shutdown phase.
+ */
+#if !defined(OS_CFG_SSSP_SHUTDOWN)
+  #define AMIROOS_CFG_SSSP_SHUTDOWN             false
+#else
+  #define AMIROOS_CFG_SSSP_SHUTDOWN             OS_CFG_SSSP_SHUTDOWN
+#endif
+
+/**
+ * @brief   Flag to indicate, whether the module stack initialization (MSI; stage 3 of the SSSP startup phase) shall be executed.
+ * @brief   In order to execute MSI, a broadcast bus (BCB) and according interfaces must be defined.
+ */
+#if !defined(OS_CFG_SSSP_MSI)
+  #define AMIROOS_CFG_SSSP_MSI                  false
+#else
+  #define AMIROOS_CFG_SSSP_MSI                  OS_CFG_SSSP_MSI
+#endif
+
+/**
+ * @brief   Width of the @p aos_sssp_moduleid_t type.
+ * @details Possible settings are 8, 16 and 32.
+ */
+#if !defined(OS_CFG_SSSP_MODULEIDWIDTH)
+  #define AMIROOS_CFG_SSSP_MODULEIDWIDTH        16
+#else
+  #define AMIROOS_CFG_SSSP_MODULEIDWIDTH        OS_CFG_SSSP_MODULEIDWIDTH
+#endif
+
+/**
  * @brief   Flag to set the module as SSSP master.
  * @details There must be only one module with this flag set to true in a system.
  */
diff --git a/modules/DiWheelDrive_1-1/board.c b/modules/DiWheelDrive_1-1/board.c
index 0ef0984..059caec 100644
--- a/modules/DiWheelDrive_1-1/board.c
+++ b/modules/DiWheelDrive_1-1/board.c
@@ -26,6 +26,18 @@ along with this program.  If not, see <http://www.gnu.org/licenses/>.
 
 #include <hal.h>
 
+/*===========================================================================*/
+/* Driver local definitions.                                                 */
+/*===========================================================================*/
+
+/*===========================================================================*/
+/* Driver exported variables.                                                */
+/*===========================================================================*/
+
+/*===========================================================================*/
+/* Driver local variables and types.                                         */
+/*===========================================================================*/
+
 #if HAL_USE_PAL || defined(__DOXYGEN__)
 /**
  * @brief   PAL setup.
@@ -57,6 +69,18 @@ const PALConfig pal_default_config = {
 };
 #endif
 
+/*===========================================================================*/
+/* Driver local functions.                                                   */
+/*===========================================================================*/
+
+/*===========================================================================*/
+/* Driver interrupt handlers.                                                */
+/*===========================================================================*/
+
+/*===========================================================================*/
+/* Driver exported functions.                                                */
+/*===========================================================================*/
+
 /**
  * @brief   Early initialization code.
  * @details This initialization must be performed just after stack setup
diff --git a/modules/DiWheelDrive_1-1/board.h b/modules/DiWheelDrive_1-1/board.h
index 0403412..1832e08 100644
--- a/modules/DiWheelDrive_1-1/board.h
+++ b/modules/DiWheelDrive_1-1/board.h
@@ -27,6 +27,10 @@ along with this program.  If not, see <http://www.gnu.org/licenses/>.
 #ifndef BOARD_H
 #define BOARD_H
 
+/*===========================================================================*/
+/* Driver constants.                                                         */
+/*===========================================================================*/
+
 /*
  * Setup for AMiRo DiWheelDrive v1.1 board.
  */
@@ -232,6 +236,22 @@ along with this program.  If not, see <http://www.gnu.org/licenses/>.
 #define LINE_OSC_OUT                PAL_LINE(GPIOD, GPIOD_OSC_OUT)
 #define LINE_SYS_WARMRST_N          PAL_LINE(GPIOD, GPIOD_SYS_WARMRST_N)
 
+/*===========================================================================*/
+/* Driver pre-compile time settings.                                         */
+/*===========================================================================*/
+
+/*===========================================================================*/
+/* Derived constants and error checks.                                       */
+/*===========================================================================*/
+
+/*===========================================================================*/
+/* Driver data structures and types.                                         */
+/*===========================================================================*/
+
+/*===========================================================================*/
+/* Driver macros.                                                            */
+/*===========================================================================*/
+
 /*
  * I/O ports initial setup, this configuration is established soon after reset
  * in the initialization code.
@@ -632,6 +652,10 @@ along with this program.  If not, see <http://www.gnu.org/licenses/>.
                                      PIN_ODR_LOW(GPIOG_PIN14) |                                                    \
                                      PIN_ODR_LOW(GPIOG_PIN15))
 
+/*===========================================================================*/
+/* External declarations.                                                    */
+/*===========================================================================*/
+
 #if !defined(_FROM_ASM_)
 #ifdef __cplusplus
 extern "C" {
diff --git a/modules/DiWheelDrive_1-1/chconf.h b/modules/DiWheelDrive_1-1/chconf.h
index d8de561..e3f5064 100644
--- a/modules/DiWheelDrive_1-1/chconf.h
+++ b/modules/DiWheelDrive_1-1/chconf.h
@@ -136,12 +136,6 @@
 /*===========================================================================*/
 
 /**
- * @brief   NVIC VTOR initialization offset.
- * @details On initialization, the code at this address in the flash memory will be executed.
- */
-#define CORTEX_VTOR_INIT                        0x00006000U
-
-/**
  * @brief   Flag to enable/disable sleep mode when the system is idle.
  */
 #define CORTEX_ENABLE_WFI_IDLE                  TRUE
diff --git a/modules/DiWheelDrive_1-1/module.c b/modules/DiWheelDrive_1-1/module.c
index 0cf6a90..b401687 100644
--- a/modules/DiWheelDrive_1-1/module.c
+++ b/modules/DiWheelDrive_1-1/module.c
@@ -339,9 +339,9 @@ ROMCONST apalControlGpio_t moduleGpioSysWarmrst = {
  */
 /*===========================================================================*/
 
-#if (AMIROOS_CFG_SHELL_ENABLE == true) || (AMIROOS_CFG_TESTS_ENABLE == true) || defined(__DOXYGEN__)
+#if (AMIROOS_CFG_SHELL_ENABLE == true) || defined(__DOXYGEN__)
 ROMCONST char* moduleShellPrompt = "DiWheelDrive";
-#endif /* (AMIROOS_CFG_SHELL_ENABLE == true) || (AMIROOS_CFG_TESTS_ENABLE == true) */
+#endif /* (AMIROOS_CFG_SHELL_ENABLE == true) */
 
 /** @} */
 
diff --git a/modules/DiWheelDrive_1-1/module.h b/modules/DiWheelDrive_1-1/module.h
index fb91d71..b56b32b 100644
--- a/modules/DiWheelDrive_1-1/module.h
+++ b/modules/DiWheelDrive_1-1/module.h
@@ -242,85 +242,84 @@ extern ROMCONST apalControlGpio_t moduleGpioSysWarmrst;
 /**
  * @brief   Event flag to be set on a SYS_SYNC interrupt.
  */
-#define MODULE_OS_IOEVENTFLAGS_SYSSYNC          AOS_IOEVENT_FLAG(PAL_PAD(LINE_SYS_INT_N))
+#define MODULE_OS_GPIOEVENTFLAG_SYSSYNC         AOS_GPIOEVENT_FLAG(PAL_PAD(LINE_SYS_INT_N))
 
 /**
  * @brief   Event flag to be set on a SYS_WARMRST interrupt.
  */
-#define MODULE_OS_IOEVENTFLAGS_SYSWARMRST       AOS_IOEVENT_FLAG(PAL_PAD(LINE_SYS_WARMRST_N))
+#define MODULE_OS_GPIOEVENTFLAG_SYSWARMRST      AOS_GPIOEVENT_FLAG(PAL_PAD(LINE_SYS_WARMRST_N))
 
 /**
  * @brief   Event flag to be set on a PATH_DCSTAT interrupt.
  */
-#define MODULE_OS_IOEVENTFLAGS_PATHDCSTAT       AOS_IOEVENT_FLAG(PAL_PAD(LINE_PATH_DCEN))
+#define MODULE_OS_GPIOEVENTFLAG_PATHDCSTAT      AOS_GPIOEVENT_FLAG(PAL_PAD(LINE_PATH_DCEN))
 
 /**
  * @brief   Event flag to be set on a COMPASS_DRDY interrupt.
  */
-#define MODULE_OS_IOEVENTFLAGS_COMPASSDRDY      AOS_IOEVENT_FLAG(PAL_PAD(LINE_COMPASS_DRDY))
+#define MODULE_OS_GPIOEVENTFLAG_COMPASSDRDY     AOS_GPIOEVENT_FLAG(PAL_PAD(LINE_COMPASS_DRDY))
 
 /**
  * @brief   Event flag to be set on a SYS_PD interrupt.
  */
-#define MODULE_OS_IOEVENTFLAGS_SYSPD            AOS_IOEVENT_FLAG(PAL_PAD(LINE_SYS_PD_N))
+#define MODULE_OS_GPIOEVENTFLAG_SYSPD           AOS_GPIOEVENT_FLAG(PAL_PAD(LINE_SYS_PD_N))
 
 /**
  * @brief   Event flag to be set on a SYS_REG_EN interrupt.
  */
-#define MODULE_OS_IOEVENTFLAGS_SYSREGEN         AOS_IOEVENT_FLAG(PAL_PAD(LINE_SYS_REG_EN))
+#define MODULE_OS_GPIOEVENTFLAG_SYSREGEN        AOS_GPIOEVENT_FLAG(PAL_PAD(LINE_SYS_REG_EN))
 
 /**
  * @brief   Event flag to be set on a IR_INT interrupt.
  */
-#define MODULE_OS_IOEVENTFLAGS_IRINT            AOS_IOEVENT_FLAG(PAL_PAD(LINE_IR_INT))
+#define MODULE_OS_GPIOEVENTFLAG_IRINT           AOS_GPIOEVENT_FLAG(PAL_PAD(LINE_IR_INT))
 
 /**
  * @brief   Event flag to be set on a GYRO_DRDY interrupt.
  */
-#define MODULE_OS_IOEVENTFLAGS_GYRODRDY         AOS_IOEVENT_FLAG(PAL_PAD(LINE_GYRO_DRDY))
+#define MODULE_OS_GPIOEVENTFLAG_GYRODRDY        AOS_GPIOEVENT_FLAG(PAL_PAD(LINE_GYRO_DRDY))
 
 /**
  * @brief   Event flag to be set on a SYS_UART_UP interrupt.
  */
-#define MODULE_OS_IOEVENTFLAGS_SYSUARTUP        AOS_IOEVENT_FLAG(PAL_PAD(LINE_SYS_UART_UP))
+#define MODULE_OS_GPIOEVENTFLAG_SYSUARTUP       AOS_GPIOEVENT_FLAG(PAL_PAD(LINE_SYS_UART_UP))
 
 /**
  * @brief   Event flag to be set on a ACCEL_INT interrupt.
  */
-#define MODULE_OS_IOEVENTFLAGS_ACCELINT         AOS_IOEVENT_FLAG(PAL_PAD(LINE_ACCEL_INT_N))
+#define MODULE_OS_GPIOEVENTFLAG_ACCELINT        AOS_GPIOEVENT_FLAG(PAL_PAD(LINE_ACCEL_INT_N))
 
-#if (AMIROOS_CFG_SHELL_ENABLE == true) || (AMIROOS_CFG_TESTS_ENABLE == true) || defined(__DOXYGEN__)
+#if (AMIROOS_CFG_SHELL_ENABLE == true) || defined(__DOXYGEN__)
 /**
  * @brief   Shell prompt text.
  */
 extern ROMCONST char* moduleShellPrompt;
-#endif /* (AMIROOS_CFG_SHELL_ENABLE == true) || (AMIROOS_CFG_TESTS_ENABLE == true) */
+#endif /* (AMIROOS_CFG_SHELL_ENABLE == true) */
 
 /**
  * @brief   Interrupt initialization macro.
- * @note    SSSP related interrupt signals are already initialized in 'aos_system.c'.
  */
 #define MODULE_INIT_INTERRUPTS() {                                            \
   /* COMPASS_DRDY */                                                          \
-  palSetLineCallback(moduleGpioCompassDrdy.gpio->line, aosSysGetStdExtiCallback(), &moduleGpioCompassDrdy.gpio->line);  \
+  palSetLineCallback(moduleGpioCompassDrdy.gpio->line, aosSysGetStdGpioCallback(), &moduleGpioCompassDrdy.gpio->line);  \
   palEnableLineEvent(moduleGpioCompassDrdy.gpio->line, APAL2CH_EDGE(moduleGpioCompassDrdy.meta.edge));                  \
   /* IR_INT */                                                                \
-  palSetLineCallback(moduleGpioIrInt.gpio->line, aosSysGetStdExtiCallback(), &moduleGpioIrInt.gpio->line);  \
+  palSetLineCallback(moduleGpioIrInt.gpio->line, aosSysGetStdGpioCallback(), &moduleGpioIrInt.gpio->line);  \
   palEnableLineEvent(moduleGpioIrInt.gpio->line, APAL2CH_EDGE(moduleGpioIrInt.meta.edge));                  \
   /* GYRO_DRDY */                                                             \
-  palSetLineCallback(moduleGpioGyroDrdy.gpio->line, aosSysGetStdExtiCallback(), &moduleGpioGyroDrdy.gpio->line);  \
+  palSetLineCallback(moduleGpioGyroDrdy.gpio->line, aosSysGetStdGpioCallback(), &moduleGpioGyroDrdy.gpio->line);  \
   palEnableLineEvent(moduleGpioGyroDrdy.gpio->line, APAL2CH_EDGE(moduleGpioGyroDrdy.meta.edge));                  \
   /* ACCEL_INT */                                                             \
-  palSetLineCallback(moduleGpioAccelInt.gpio->line, aosSysGetStdExtiCallback(), &moduleGpioAccelInt.gpio->line);  \
+  palSetLineCallback(moduleGpioAccelInt.gpio->line, aosSysGetStdGpioCallback(), &moduleGpioAccelInt.gpio->line);  \
   palEnableLineEvent(moduleGpioAccelInt.gpio->line, APAL2CH_EDGE(moduleGpioAccelInt.meta.edge));                  \
   /* PATH_DCSTAT */                                                           \
-  palSetLineCallback(moduleGpioPathDcStat.gpio->line, aosSysGetStdExtiCallback(), &moduleGpioPathDcStat.gpio->line);  \
+  palSetLineCallback(moduleGpioPathDcStat.gpio->line, aosSysGetStdGpioCallback(), &moduleGpioPathDcStat.gpio->line);  \
   palEnableLineEvent(moduleGpioPathDcStat.gpio->line, APAL2CH_EDGE(moduleGpioPathDcStat.meta.edge));                  \
   /* SYS_REG_EN */                                                            \
-  palSetLineCallback(moduleGpioSysRegEn.gpio->line, aosSysGetStdExtiCallback(), &moduleGpioSysRegEn.gpio->line);  \
+  palSetLineCallback(moduleGpioSysRegEn.gpio->line, aosSysGetStdGpioCallback(), &moduleGpioSysRegEn.gpio->line);  \
   palEnableLineEvent(moduleGpioSysRegEn.gpio->line, APAL2CH_EDGE(moduleGpioSysRegEn.meta.edge));                  \
   /* SYS_WARMRST */                                                           \
-  palSetLineCallback(moduleGpioSysWarmrst.gpio->line, aosSysGetStdExtiCallback(), &moduleGpioSysWarmrst.gpio->line);  \
+  palSetLineCallback(moduleGpioSysWarmrst.gpio->line, aosSysGetStdGpioCallback(), &moduleGpioSysWarmrst.gpio->line);  \
   palEnableLineEvent(moduleGpioSysWarmrst.gpio->line, APAL2CH_EDGE(moduleGpioSysWarmrst.meta.edge));                  \
 }
 
@@ -328,7 +327,7 @@ extern ROMCONST char* moduleShellPrompt;
  * @brief   Test initialization hook.
  */
 #define MODULE_INIT_TESTS() {                                                 \
-  /* initialize tests and add to shell */                                     \
+  /* add test commands to shell */                                            \
   aosShellAddCommand(&aos.shell, &moduleTestA3906ShellCmd);                   \
   aosShellAddCommand(&aos.shell, &moduleTestAt24c01bShellCmd);                \
   aosShellAddCommand(&aos.shell, &moduleTestHmc5883lShellCmd);                \
@@ -367,12 +366,16 @@ extern ROMCONST char* moduleShellPrompt;
   qeiStart(&MODULE_HAL_QEI_RIGHT_WHEEL, &moduleHalQeiConfig);                 \
   qeiEnable(&MODULE_HAL_QEI_LEFT_WHEEL);                                      \
   qeiEnable(&MODULE_HAL_QEI_RIGHT_WHEEL);                                     \
+  /* CAN */                                                                   \
+  canStart(&MODULE_HAL_CAN, &moduleHalCanConfig);                             \
 }
 
 /**
  * @brief   Periphery communication interface deinitialization hook.
  */
 #define MODULE_SHUTDOWN_PERIPHERY_IF() {                                      \
+  /* CAN */                                                                   \
+  canStop(&MODULE_HAL_CAN);                                                   \
   /* PWM */                                                                   \
   pwmStop(&MODULE_HAL_PWM_DRIVE);                                             \
   /* QEI */                                                                   \
@@ -395,35 +398,39 @@ extern ROMCONST char* moduleShellPrompt;
  */
 /*===========================================================================*/
 
+#if (AMIROOS_CFG_SSSP_ENABLE == true) || defined(__DOXYGEN__)
+
 /**
  * @brief   PD signal GPIO.
  */
-#define moduleSsspGpioPd                        moduleGpioSysPd
+#define moduleSsspGpioPD                        moduleGpioSysPd
 
 /**
- * @brief   SYNC signal GPIO.
+ * @brief   S signal GPIO.
  */
-#define moduleSsspGpioSync                      moduleGpioSysSync
+#define moduleSsspGpioS                         moduleGpioSysSync
 
 /**
  * @brief   UP signal GPIO.
  */
-#define moduleSsspGpioUp                        moduleGpioSysUartUp
+#define moduleSsspGpioUP                        moduleGpioSysUartUp
 
 /**
- * @brief   Event flags for PD signal events.
+ * @brief   Event flag for PD signal events.
  */
-#define MODULE_SSSP_EVENTFLAGS_PD               MODULE_OS_IOEVENTFLAGS_SYSPD
+#define MODULE_SSSP_EVENTFLAG_PD                MODULE_OS_GPIOEVENTFLAG_SYSPD
 
 /**
- * @brief   Event flags for SYNC signal events.
+ * @brief   Event flag for S signal events.
  */
-#define MODULE_SSSP_EVENTFLAGS_SYNC             MODULE_OS_IOEVENTFLAGS_SYSSYNC
+#define MODULE_SSSP_EVENTFLAG_S                 MODULE_OS_GPIOEVENTFLAG_SYSSYNC
 
 /**
- * @brief   Event flags for UP signal events.
+ * @brief   Event flag for UP signal events.
  */
-#define MODULE_SSSP_EVENTFLAGS_UP               MODULE_OS_IOEVENTFLAGS_SYSUARTUP
+#define MODULE_SSSP_EVENTFLAG_UP                MODULE_OS_GPIOEVENTFLAG_SYSUARTUP
+
+#endif /* (AMIROOS_CFG_SSSP_ENABLE == true) */
 
 /** @} */
 
diff --git a/modules/DiWheelDrive_1-1/test/HMC5883L/module_test_HMC5883L.c b/modules/DiWheelDrive_1-1/test/HMC5883L/module_test_HMC5883L.c
index bd6fa19..f546627 100644
--- a/modules/DiWheelDrive_1-1/test/HMC5883L/module_test_HMC5883L.c
+++ b/modules/DiWheelDrive_1-1/test/HMC5883L/module_test_HMC5883L.c
@@ -41,8 +41,8 @@ along with this program.  If not, see <http://www.gnu.org/licenses/>.
 
 static aos_test_hmc5883ldata_t _data = {
   /* HMC driver   */ &moduleLldCompass,
-  /* event source */ &aos.events.io,
-  /* event flags  */ MODULE_OS_IOEVENTFLAGS_COMPASSDRDY,
+  /* event source */ &aos.events.gpio,
+  /* event flags  */ MODULE_OS_GPIOEVENTFLAG_COMPASSDRDY,
   /* timeout      */ MICROSECONDS_PER_SECOND,
 };
 
diff --git a/modules/DiWheelDrive_1-1/test/L3G4200D/module_test_L3G4200D.c b/modules/DiWheelDrive_1-1/test/L3G4200D/module_test_L3G4200D.c
index 67f170c..7017044 100644
--- a/modules/DiWheelDrive_1-1/test/L3G4200D/module_test_L3G4200D.c
+++ b/modules/DiWheelDrive_1-1/test/L3G4200D/module_test_L3G4200D.c
@@ -42,8 +42,8 @@ along with this program.  If not, see <http://www.gnu.org/licenses/>.
 static aos_test_l3g4200ddata_t _data = {
   /* driver            */ &moduleLldGyroscope,
   /* SPI configuration */ &moduleHalSpiGyroscopeConfig,
-  /* event source */ &aos.events.io,
-  /* event flags  */ MODULE_OS_IOEVENTFLAGS_GYRODRDY,
+  /* event source */ &aos.events.gpio,
+  /* event flags  */ MODULE_OS_GPIOEVENTFLAG_GYRODRDY,
 };
 
 static AOS_TEST(_test, "L3G4200D", "Gyroscope", moduleTestL3g4200dShellCb, aosTestL3g4200dFunc, &_data);
diff --git a/modules/DiWheelDrive_1-1/test/LIS331DLH/module_test_LIS331DLH.c b/modules/DiWheelDrive_1-1/test/LIS331DLH/module_test_LIS331DLH.c
index 7ea0cdc..9644b0e 100644
--- a/modules/DiWheelDrive_1-1/test/LIS331DLH/module_test_LIS331DLH.c
+++ b/modules/DiWheelDrive_1-1/test/LIS331DLH/module_test_LIS331DLH.c
@@ -42,8 +42,8 @@ along with this program.  If not, see <http://www.gnu.org/licenses/>.
 static aos_test_lis331dlhdata_t _data = {
   /* driver            */ &moduleLldAccelerometer,
   /* SPI configuration */ &moduleHalSpiAccelerometerConfig,
-  /* event source */ &aos.events.io,
-  /* event flags  */ MODULE_OS_IOEVENTFLAGS_ACCELINT,
+  /* event source */ &aos.events.gpio,
+  /* event flags  */ MODULE_OS_GPIOEVENTFLAG_ACCELINT,
 };
 
 static AOS_TEST(_test, "LIS331DLH", "Accelerometer", moduleTestLis331dlhShellCb, aosTestLis331dlhFunc, &_data);
diff --git a/modules/DiWheelDrive_1-1/test/VCNL4020/module_test_VCNL4020.c b/modules/DiWheelDrive_1-1/test/VCNL4020/module_test_VCNL4020.c
index 5d1670f..60ec57d 100644
--- a/modules/DiWheelDrive_1-1/test/VCNL4020/module_test_VCNL4020.c
+++ b/modules/DiWheelDrive_1-1/test/VCNL4020/module_test_VCNL4020.c
@@ -43,8 +43,8 @@ along with this program.  If not, see <http://www.gnu.org/licenses/>.
 static aos_test_vcnl4020data_t _data = {
   /* driver       */ &moduleLldProximity,
   /* timeout      */ MICROSECONDS_PER_SECOND,
-  /* event source */ &aos.events.io,
-  /* event flags  */ MODULE_OS_IOEVENTFLAGS_IRINT,
+  /* event source */ &aos.events.gpio,
+  /* event flags  */ MODULE_OS_GPIOEVENTFLAG_IRINT,
 };
 
 static AOS_TEST(_test, "VCNL4020", "proximity sensor", moduleTestVcnl4020ShellCb, aosTestVcnl4020Func, &_data);
diff --git a/modules/DiWheelDrive_1-2/aosconf.h b/modules/DiWheelDrive_1-2/aosconf.h
index 44f464b..549f682 100644
--- a/modules/DiWheelDrive_1-2/aosconf.h
+++ b/modules/DiWheelDrive_1-2/aosconf.h
@@ -33,7 +33,7 @@ along with this program.  If not, see <http://www.gnu.org/licenses/>.
  */
 #define _AMIRO_OS_CFG_
 #define AMIRO_OS_CFG_VERSION_MAJOR              2
-#define AMIRO_OS_CFG_VERSION_MINOR              0
+#define AMIRO_OS_CFG_VERSION_MINOR              1
 
 #include <stdbool.h>
 
@@ -80,14 +80,14 @@ along with this program.  If not, see <http://www.gnu.org/licenses/>.
 #endif /* !defined(OS_CFG_PROFILE) */
 
 /**
- * @brief   Mask for the control thread to listen to certain IO events.
+ * @brief   Mask for the control thread to listen to certain GPIO events.
  * @note    Any mandatory events (e.g. for SSSP) are enabled implicitely despite this configuration.
  */
-#if !defined(OS_CFG_MAIN_LOOP_IOEVENT_MASK)
-  #define AMIROOS_CFG_MAIN_LOOP_IOEVENT_MASK    0
-#else /* !defined(OS_CFG_MAIN_LOOP_IOEVENT_MASK) */
-  #define AMIROOS_CFG_MAIN_LOOP_IOEVENT_MASK    OS_CFG_MAIN_LOOP_IOEVENT_MASK
-#endif /* !defined(OS_CFG_MAIN_LOOP_IOEVENT_MASK) */
+#if !defined(OS_CFG_MAIN_LOOP_GPIOEVENT_FLAGSMASK)
+  #define AMIROOS_CFG_MAIN_LOOP_GPIOEVENT_FLAGSMASK 0
+#else /* !defined(OS_CFG_MAIN_LOOP_GPIOEVENT_FLAGSMASK) */
+  #define AMIROOS_CFG_MAIN_LOOP_GPIOEVENT_FLAGSMASK OS_CFG_MAIN_LOOP_GPIOEVENT_FLAGSMASK
+#endif /* !defined(OS_CFG_MAIN_LOOP_GPIOEVENT_FLAGSMASK) */
 
 /**
  * @brief   Timeout value when waiting for events in the main loop in microseconds.
@@ -103,6 +103,21 @@ along with this program.  If not, see <http://www.gnu.org/licenses/>.
 
 /*===========================================================================*/
 /**
+ * @name Bootloader configuration
+ * @{
+ */
+/*===========================================================================*/
+
+/**
+ * @brief   Identifier of the instaled bootloader (if any).
+ * @note    See aos_bootloader.h file for a list of available settings.
+ */
+#define AMIROOS_CFG_BOOTLOADER                  AOS_BOOTLOADER_AMiRoBLT
+
+/** @} */
+
+/*===========================================================================*/
+/**
  * @name SSSP (Startup Shutdown Synchronization Protocol) configuration.
  * @{
  */
@@ -118,6 +133,46 @@ along with this program.  If not, see <http://www.gnu.org/licenses/>.
 #endif /* !defined(OS_CFG_SSSP_ENABLE) */
 
 /**
+ * @brief   Flag to indicate, whether the SSSP startup sequence shall be executed by AMiRo-OS.
+ * @details This setting must be false in case another software (e.g. a bootloader) handles the initial stages of the SSSP startup phase.
+ */
+#if !defined(OS_CFG_SSSP_STARTUP)
+  #define AMIROOS_CFG_SSSP_STARTUP              false
+#else
+  #define AMIROOS_CFG_SSSP_STARTUP              OS_CFG_SSSP_STARTUP
+#endif
+
+/**
+ * @brief   Flag to indicate, whether the SSSP shutdown sequence shall be executed by AMiRo-OS.
+ * @details This setting should be false in case another software (e.g. a bootloader) handles the final stages of the SSSP shutdown phase.
+ */
+#if !defined(OS_CFG_SSSP_SHUTDOWN)
+  #define AMIROOS_CFG_SSSP_SHUTDOWN             false
+#else
+  #define AMIROOS_CFG_SSSP_SHUTDOWN             OS_CFG_SSSP_SHUTDOWN
+#endif
+
+/**
+ * @brief   Flag to indicate, whether the module stack initialization (MSI; stage 3 of the SSSP startup phase) shall be executed.
+ * @brief   In order to execute MSI, a broadcast bus (BCB) and according interfaces must be defined.
+ */
+#if !defined(OS_CFG_SSSP_MSI)
+  #define AMIROOS_CFG_SSSP_MSI                  false
+#else
+  #define AMIROOS_CFG_SSSP_MSI                  OS_CFG_SSSP_MSI
+#endif
+
+/**
+ * @brief   Width of the @p aos_sssp_moduleid_t type.
+ * @details Possible settings are 8, 16 and 32.
+ */
+#if !defined(OS_CFG_SSSP_MODULEIDWIDTH)
+  #define AMIROOS_CFG_SSSP_MODULEIDWIDTH        16
+#else
+  #define AMIROOS_CFG_SSSP_MODULEIDWIDTH        OS_CFG_SSSP_MODULEIDWIDTH
+#endif
+
+/**
  * @brief   Flag to set the module as SSSP master.
  * @details There must be only one module with this flag set to true in a system.
  */
diff --git a/modules/DiWheelDrive_1-2/board.c b/modules/DiWheelDrive_1-2/board.c
index f624c7c..3c4c143 100644
--- a/modules/DiWheelDrive_1-2/board.c
+++ b/modules/DiWheelDrive_1-2/board.c
@@ -26,6 +26,18 @@ along with this program.  If not, see <http://www.gnu.org/licenses/>.
 
 #include <hal.h>
 
+/*===========================================================================*/
+/* Driver local definitions.                                                 */
+/*===========================================================================*/
+
+/*===========================================================================*/
+/* Driver exported variables.                                                */
+/*===========================================================================*/
+
+/*===========================================================================*/
+/* Driver local variables and types.                                         */
+/*===========================================================================*/
+
 #if HAL_USE_PAL || defined(__DOXYGEN__)
 /**
  * @brief   PAL setup.
@@ -57,6 +69,18 @@ const PALConfig pal_default_config = {
 };
 #endif
 
+/*===========================================================================*/
+/* Driver local functions.                                                   */
+/*===========================================================================*/
+
+/*===========================================================================*/
+/* Driver interrupt handlers.                                                */
+/*===========================================================================*/
+
+/*===========================================================================*/
+/* Driver exported functions.                                                */
+/*===========================================================================*/
+
 /**
  * @brief   Early initialization code.
  * @details This initialization must be performed just after stack setup
